Listing 2 -- code to run WordPerfect from within the application

; ---------------------------------------------------------------------------
; analwp() launches wp5.1 to keep analysis info
; ---------------------------------------------------------------------------
Proc analwp()
    Private     procname, number, nd, lev, choice
    procname = "analwp"
    ClearAll
        If Not pass(0) Then     ; bad password
                Return
        EndIf
        PassWord passw                  ; passw is a global var
    Lock "srrmstr"pfl
    If (RetVal=False) Then
        dispmess(ErrorMessage(),"",True)
        ClearAll
        Return
    EndIf

        ; make sure there are records out there!
        If NRecords("srrmstr")=0 Then
                dispmess("SRR master table is empty.","",True)
        UnLock "srrmstr"pfl
                Return
        EndIf

        number=""
        Clear
    View "srrmstr"
    PickForm "2"

    While (True)

        Wait Table
            Prompt "Browsing SRR Log File",
            "Esc to end, F2 to prepare analysis summary"
        Until "Esc","F2"

        If (RetVal="Esc") Then
                UnLock "srrmstr"pfl
            ClearAll
            Return
        EndIf

        number=[srrmstr->control no.]
        nd=anad        ; anad is a global var pointing to analysis directory

                ; lev=1 people can read/write srr analysis documents
                ; lev=0 people can only read them

                If lev < 1 Then         ; the user can only view the file
            If Not IsFile(nd+number) Then   ; there is no analysis
                dispmess("Analysis does not exist.","",True)
                Loop
            Else
                                ; lock the srr number to prevent
                                ; lev=1 analysis writers from making changes
                        Lock number pfl
                        If Not RetVal Then
                        dispmess(ErrorMessage(),"Try again later.",True)
                        Loop
                        EndIf
                                ; mark the file as read-only
                Run NoRefresh  "attrib +R "+nd+number+" > NUL"
            EndIf
        Else    ; the user has rights to edit and create file
            If Not IsFile(nd+number) Then ; the file does not exist
                ShowMenu
                    "Yes" : "Analysis summary does not exist. Create one?",
                    "No"  : "Analysis summary does not exist. Create one?"
                    Default "No"
                To choice

                If choice <> "Yes" Then   ; don't create one
                    Loop                  ; go to top of while loop
                EndIf

                                ; keep out all lev=0 people from this document
                                Lock number fl
                        If Not RetVal Then
                        dispmess(ErrorMessage(),"Try again later.",True)
                        Loop
                        EndIf

                ; copy the header file to the new srr number
                Run NoRefresh "copy "+nd+"header"+" "+nd+number+" > NUL"
            EndIf
                        ; mark the file as read/write
            Run  NoRefresh "attrib -R "+nd+number+" > NUL"

        EndIf

        dispmess("Loading WordPerfect 5.1...","Please wait.",False)

        ; delete the old batch file, if it exists
        If IsFile(PrivDir()+"wp1.bat") Then
            Run NoRefresh "del "+PrivDir()+"wp1.bat > NUL"
        EndIf

        ; write the batch file, then run it
                ; nd+number is the path and file name to edit
        Print File PrivDir()+"wp1.bat" wpcommand+" "+nd+number+"\n"
        Run Big NoRefresh PrivDir()+"wp1"

        ; reset the file as read-only
        If lev > 0 Then
            If IsFile(nd+number) Then
                Run NoRefresh "attrib +R "+nd+number+" > NUL"
            EndIf
        EndIf

                ; remove the proper lock
                If lev>0 Then
                UnLock number fl
                Else
                        Unlock number pfl
                EndIf
    EndWhile

    UnLock "srrmstr"pfl
    ClearAll
    Clear
        UnPassword passw

EndProc


