/*

       Function: DBFOPEN()
       Used for opening all dbf's in the system. Guarentees you don't 
       accidentally close a database in a workarea

*/
FUNCTION Dbfopen(sDname, sDroom)
LOCAL tRetval  // return if dbf was already open
// Opens a database if not already open, selects if already open
IF VALTYPE("sDname") == "N"
  sDname := ALIAS(sDname) // force to an alias if select area was passed in
END
IF SELECT(sDname) == 0 // if it's not already open, then...
  tRetval := .F.
  IF Pcount() == 2
    USE (sDname) ALIAS &sDroom NEW
  ELSE
    USE (sDname)
  END
ELSE
  tRetval := .T.
  SELECT (SELECT(sDname))
END
RETURN tRetval
/*

       Function: DBFCLOSE()

*/
FUNCTION Dbfclose(sDroom)   // NOTE: you must pass the Alias
// Closes a database whether it is selected or not, returns to starting area
LOCAL sBookmark := ALIAS()  // save current location
IF SELECT(sDroom) <> 0
  SELECT (SELECT(sDroom))   // if not already closed, go close it
  USE
END
IF sBookmark <> sDroom        // return to original work area
  SELECT (SELECT(sBookmark))
END
RETURN NIL
