Listing 3 -- The code that implements an audit trail

Proc invupddet()
    Private procname, ; procedure name
    fold, fnew,      ; old and new record arrays for audit control
    copybuff,        ; copy array to hold record for pasting
    insert,          ; logical variable to flag for a new record
    choice,          ; ShowMenu result variable
    k1,k2,           ; two keypress variables for duplicate checking
    lo,ld,it,        ; these three hold invdet key values for locate
    opt,             ; temp variable to hold RetVal
    x,               ; counter variable
    errval           ; holds verrorcode() result

    insert=False
    procname="invupddet"
    errval=0

    While (True)
        If Table()<>"Invdet" Then
            MoveTo "Invdet"
        EndIf

                ; don't let the user make changes yet
        ImageRights ReadOnly

        Wait Table
            Prompt "Viewing detail records",
            "F3 master, F9 edit record, Alt-C copy"
        Until "F3","F9",-46
        Switch
            Case RetVal="F3" :
                QuitLoop
            Case RetVal=-46  :
                ImageRights
                invcopy()
                Loop
        EndSwitch

                ; user must have pressed F9
                ImageRights

        While (True)
                        ; make a copy of the original record!
            CopyToArray fold

            While True

                Wait Record
                    Prompt "Editing detail records",
                    "Esc end, F1 look, F8 transfer, Alt-C copy, Alt-P paste,
Ins, Del"
                Until "Esc","Ins","Del","F8",-25,-46
                opt=RetVal
                Switch
                    Case opt=-25 : invpaste()
                        Loop
                    Case opt=-46 : invcopy()
                        Loop
                EndSwitch

                lo=[location code]
                ld=[location/description]
                it=[item number]

                ; check for duplicate keys
                If opt<>"Del" And NImageRecords()>1 Then
                    Switch
                        Case AtLast()  : k1="CtrlPgUp" k2="CtrlPgDn"
                        OtherWise      : k1="CtrlPgDn" k2="CtrlPgUp"
                    EndSwitch
                    KeyPress k1
                    errval=verrorcode()
                    If errval>0 Then
                        dispmess(vmess,"",True)
                    Else
                        Locate lo,ld,it
                        QuitLoop
                    EndIf
                Else
                    QuitLoop
                EndIf
            EndWhile

                        ; make a copy of the new record
                        CopyToArray fnew

            If insert=True And opt<>"Del" Then
                                ; we've inserted a new record
                If invchange("ins","","","","","")=False Then
                    Loop
                EndIf
                insert=False
            Else
                                ; otherwise, check to see if anything has changed
                invchange("check","","","","","")
            EndIf

            Switch
                Case opt="Ins" :
                    ShowMenu
                        "Yes" : "Insert a new item",
                        "No"  : "Do not insert a new item"
                        Default "Yes"
                    To choice
                    If choice<>"Yes" Then
                        Loop
                    EndIf
                    Ins
                    If verrorcode()>0 Then
                        dispmess(vmess,"(Insert)",True)
                        insert=False
                    Else
                        insert=True
                    EndIf
                Case opt="Del" :
                    ShowMenu
                        "Yes" : "Delete this item",
                        "No"  : "Do not delete this item"
                        Default "Yes"
                    To choice
                    If choice<>"Yes" Then
                        Loop
                    EndIf
                    Del
                    invchange("del","","","","","")
                Case opt="Esc" :
                    QuitLoop
                Case opt="F8" :
                    invtrans1()
            EndSwitch
        EndWhile
    EndWhile
    MoveTo "locacode"

EndProc
; ---------------------------------------------------------------------------
;  checkarr() checks two arrays for identical contents
; ---------------------------------------------------------------------------

Proc checkarr(a,b,limit)
    Private a,b,x,res,limit,procname
    procname = "checkarr"
    For x From 1 To limit
        Execute "res="+a+"[x]="+b+"[x]"
        If res=False Then
            Return False
        EndIf
    EndFor
    Return True
EndProc

; ---------------------------------------------------------------------------
;  invchange1() writes inventory audit records for record changes
; ---------------------------------------------------------------------------
Proc invchange1(a,tag)
    Private procname,a,tag
    procname="invchange1"
    [user]=UserName()
    [date]=Today()
    [time]=Time()

    Execute "[Message]= \""+tag+"\""
    Execute "[Location code]="+a+"[\"Location code\"]"
    Execute "[Location/description]="+a+"[\"Location/description\"]"
    Execute "[Item number]="+a+"[\"Item number\"]"
    Execute "[Cost]="+a+"[\"Cost\"]"
    Execute "[Vendor number]="+a+"[\"Vendor number\"]"
    Execute "[Serial number]="+a+"[\"Serial number\"]"
    Execute "[Asset tag]="+a+"[\"Asset tag\"]"
    Execute "[Quantity]="+a+"[\"Quantity\"]"
    Execute "[Install date]="+a+"[\"Install date\"]"
    Execute "[Warranty end date]="+a+"[\"Warranty end date\"]"
    Execute "[Item type]="+a+"[\"Item type\"]"

EndProc

; ---------------------------------------------------------------------------
;  invchange() determines which type of audit record to write
; ---------------------------------------------------------------------------

Proc invchange(method,vendor,po,config,locd,loccode)
    Private procname,method,oldtable,vendor,po,config,locd,loccode,rv
    procname="invchange"
    rv=True

    If NImages()>0 Then
        oldtable = Table()
    Else
        oldtable = ""
    EndIf

    Switch
        Case method="check"  :
            If checkarr("fold","fnew",ArraySize(fold)) = False Then
                MoveTo "invaudit"
                Ins
                invchange1("fold","Record changed (old)")
                Ins
                invchange1("fnew","Record changed (new)")
            EndIf
        Case method="ins"    :
            MoveTo "invaudit"
            Ins
            invchange1("fnew","Record inserted")
        Case method="del"    :
            MoveTo "invaudit"
            Ins
            invchange1("fnew","Record deleted")
        Case method="transo" :
            MoveTo "invaudit"
            Ins
            invchange1("fnew","Record transferred (old)")
        Case method="transn" :
            MoveTo "invaudit"
            Ins
            invchange1("fnew","Record transferred (new)")
        Case method="transgo" :
            invchange2("Group transferred (old)","","","",locd,loccode)
        Case method="transgn" :
            invchange2("Group transferred (new)","","","",locd,loccode)
        Case method="copypo" :
            invchange2("Group copied from PO",vendor,po,"",locd,loccode)
        Case method="copycf" :
            invchange2("Group copied from config","","",config,locd,loccode)
        Case method="changelocdo" :
            invchange2("Loc/desc changed (old)","","","",locd,loccode)
        Case method="changelocdn" :
            invchange2("Loc/desc changed (new)","","","",locd,loccode)
    EndSwitch

    If oldtable<>"" Then
        MoveTo oldtable
    EndIf
    Return rv

EndProc

