           ;Checking to see if Blank=Zero is set to "Yes"
           ;----------------------------------------------
           If Not IsBlankZero() then
              Message "Contact Support on how to re-configure this application to treat"+                        
                      "BLANKS as Zero. Press any key to exit."
              beep
              junk=getchar()
              return false
           Endif

           ; purpose: checks available free space on private and working directories
           ;          of the computer based on the parameters passed. if the check
           ;          finds less free space on either drive then requested, the user
           ;          is then prompted to chose between quiting or continuing at their
           ;          own risk. returns true or false depending on their choice
           ;          priv.dir and working.dir must be numeric
           Proc FreeSpaceCheck( priv.dir, working.dir )
           private proc.name,
                   x,
                   priv.drive.letter,
                   work.drive.letter,
                   free.space,
                   check.space,
                   Looper
           
           proc.name = "FreeSpaceCheck"
           
           For Looper From 1 to 2
              ;-- check the private directory free space
              priv.drive.letter = substr(privdir(),1,1)
              If IsBlank(priv.drive.letter) Then Loop EndIf
              work.drive.letter = substr(directory(),1,1)
              If IsBlank(work.drive.letter) Then Loop EndIf
              If Looper = 1 Then
                 free.space = drivestatus(priv.drive.letter)
                 check.space = priv.dir
              Else
                 If priv.drive.letter = work.drive.letter Then QuitLoop EndIf
                 free.space = drivestatus(work.drive.letter)
                 check.space = working.dir
              EndIf
              if free.space then
                 If Looper = 1 Then
                    free.space = drivespace(priv.drive.letter)
                 Else
                    free.space = drivespace(work.drive.letter)
                 EndIf
              else
                 Message  "Drive " + upper(priv.drive.letter) + " is not ready. Press any key"+                  
                           "to continue."
                 Beep
                 RetVal = GetChar()
                 return false
              endif
              if free.space < priv.dir then
                 ShowMsgWindow(
                 "I N S U F F I C I E N T   F R E E   D I S K   S P A C E\n"+
                 "Minimum disk free space for program to run properly: "+
                 format("w13,ec",priv.dir)+" bytes\n"+
                 "Amount of disk free space on this computer:          "+
                 format("w13,ec",free.space)+" bytes.",0,0,0,0,ErrorColor)
                 beep
                 showmenu
                    "Quit"     : "Quit the application",
                    "Continue" : "Continue, with risk of program crash due to "+
                    "insufficient free disk space"
                    default "Quit"
                 to x
                 if x = "Quit" or
                    x = "Esc" then
                    return false
                 endif
                  Clear
              endif
           EndFor
           return true
           endproc

           ; purpose: checks available memory on machine based on the value passed
           ;          in the variable memory.to.check. if the check finds less
           ;          memory then requested, the user is then prompted to chose
           ;          between quiting or continuing at their own risk. returns
           ;          true or false depending on their choice
           ;          memory.to.check must be numeric
           proc mem.left.check( memory.to.check )
           private proc.name,
                   x
           proc.name = "mem.left.check"
           
           if not memleft() >= memory.to.check then
              ShowMsgWindow(
              "I N S U F F I C I E N T   V M M   M E M O R Y\n"+
              "Minimum memory required for program to run properly: "+
              format("w12,ec",memory.to.check)+"\n"+
              "Amount of memory available on this computer:         "+
              format("w12,ec",MemLeft()),
              0,0,0,0,ErrorColor)
              beep
              showmenu
                 "Quit"     : "Quit this part of the application",
                 "Continue" : "Continue, with risk of program crash due to "+
                 "insufficient memory resources"
                 default "Quit"
              to x
              if x = "Quit" or
                 x = "Esc" then
                 return false
              endif
              Clear
           endif
           return true
           endproc
           

