

VBSQL.BAS:
'* Server connection handle
Dim SqlConn As Integer

Function Logon_Server% (Server$, UserName$, Password$)
    '*
    '* Sets up server connection for query/data exchange
    '*
    '* Initiate server link
    Msg$ = SqlInit$()
    '* Connect to server
    Dbase$ = "prospect"
    SqlConn = SqlOpenConnection(Server$, UserName$, Password$, "VBSQL", Dbase$)
    If SqlConn <> 0 Then
        '* Connection is successfull
        Logon_Server% = SUCCEED%
        '* Set database
        stmt% = SqlUse(SqlConn, Dbase$)
    End If
End Function

Function Exec_Query% (SQL$)
    '*
    '* Sends and executes query passed as a string
    '*
    '* Send query to server
    If SqlCmd(SqlConn, SQL$) = 1 Then
        '* Request query execution
        If SqlExec(SqlConn) = 1 Then
            '* Execution is successfull
            Exec_Query% = SUCCEED%
        End If
    End If
End Function

Function Get_NoData% ()
    '*
    '* Empty loop for handling queries with no results expected.
    '* Can also be used to discard unnecessary results
    '*
    '* For each result set
    Do Until SqlResults(SqlConn) = NOMORERESULTS%
        '* For each row
        Do Until SqlNextRow(SqlConn) = NOMOREROWS%
            '* Do Nothing
        Loop
    Loop
    Get_NoData% = SUCCEED%
End Function

Function Build_String$ ()
    '*
    '* Return a variable length string of the current results
    '*
    Result$ = ""
    '* For each result set
    Do Until SqlResults(SqlConn) = NOMORERESULTS%
        '* For each row
        Do Until SqlNextRow(SqlConn) = NOMOREROWS%
            '* For each column
            For item% = 1 To SqlNumCols(SqlConn)
                '* Get cell text and append to string
                Result$ = Result$ + RTrim$(SqlData(SqlConn, item%))
            Next item%
        Loop
    Loop
    '* Return the data string
    Build_String$ = Result$
End Function

Function Load_List% (SList As Control)
    '*
    '* Load current results into List or Combo Box
    '*
    '* Empty List (or Combo) first
    For item% = 1 To SList.ListCount
        SList.RemoveItem 0
    Next item%
    '*
    '* For each result set
    Do Until SqlResults(SqlConn) = NOMORERESULTS%
        '* For each row
        Do Until SqlNextRow(SqlConn) = NOMOREROWS%
            '* For each column
            Row$ = ""
            For item% = 1 To SqlNumCols(SqlConn)
                '* Get cell value and add it to the string
                Row$ = Row$ + RTrim$(SqlData(SqlConn, item%)) + " "
            Next item%
            '* Place string of row values in List (or Combo)
            SList.AddItem Row$
        Loop
    Loop
    Load_List% = SUCCEED%
End Function

Function Logoff_Server% ()
    '*
    '* Close down server connection
    '*
    '* Disconnect server process
    Call SqlClose(SqlConn)
    '* Terminate server link
    Call SqlWinExit
End Function
[End of VBSQL.BAS]

LOGON.TXT
Sub VBSQL1_Message (SqlConn As Integer, Message As Long, State As Integer,
Severity As Integer, MsgStr As String)
    '*
    '*  Error handler for server messages
    '*
    '*  Ignore Severity = 0 messages
    If Severity > 0 Then
        '* This handler simply prints the message in a Message Box
        '* and continues execution after the calling statement
        MsgNum$ = "Number " + Str$(Message)
        StaNum$ = "State " + Str$(State)
        SevNum$ = "Severity " + Str$(Severity)
        Msg$ = MsgStr + ".  " + MsgNum$ + ", " + StaNum$ + ", " + SevNum$
        MsgBox Msg$, 48, "VBSQL"
    End If
End Sub

Sub VBSQL1_Error (SqlConn As Integer, Severity As Integer, ErrorNum As Integer, 
ErrorStr As String, RetCode As Integer)
    '*
    '*  Error handler for server errors
    '*
    '*  Ignore Severity = 0 errors
    If Severity > 0 Then
        '* This handler simply prints the error in a Message Box
        '* and continues execution after the calling statement
        SevNum$ = "Severity " + Str$(Severity)
        ErrNum$ = "Number " + Str$(ErrorNum)
        RetNum$ = "Code " + Str$(RetCode)
        Msg$ = ErrorStr + ".  " + SevNum$ + ", " + ErrNum$ + ", " + RetNum$
        MsgBox Msg$, 16, "VBSQL"
    End If
End Sub

Sub OKButton_Click ()
    '*
    '* Log onto the server
    '*
    If Logon_Server((Text1.Text), (Text2.Text), (Text3.Text)) Then
        '* Successful logon moves to the Prospect form
        Logon.Hide
        Prospect.Show
    Else
        '* Failed Logon prompts and remains in the form
        MsgBox "Logon Failed.", 16, "Prospect Logon"
    End If
End Sub

Sub CancelButton_Click ()
    '*
    '* Cancel exits the form
    '*
    Unload Logon
End Sub

Sub Form_Unload (Cancel As Integer)
    '* Unloading the Logon form exits the application
    End
End Sub
[End of LOGON.TXT]

PROSPECT.TXT
Sub Form_Load ()
    '*
    '* Initializes the form
    '*
    '* Default todays date in the Date field
    TodayDate.Text = Format$(Now, "mm/dd/yy")
    '* Trigger the RetrieveButton_Click subroutine
    RetrieveButton.Value = -1
End Sub

Sub RetrieveButton_Click ()
    '*
    '* Loads the To Call and Calls Made Lists
    '*
    '* Query:  select names to call on date in Date field
    SQL$ = "SELECT name FROM Profile"
    SQL$ = SQL$ + " WHERE datediff(day, next_call, '" + TodayDate.Text + "') = 0"
    '*
    '* Execute the query and load the results into the To Call list
    If Exec_Query(SQL$) Then stmt% = Load_List(ToCall)
    '*
    '* Query:  select names called on date in Date field
    SQL$ = "SELECT p.name FROM Profile p, contact c"
    SQL$ = SQL$ + " WHERE p.prospect_id = c.prospect_id"
    SQL$ = SQL$ + " AND datediff(day,"
    SQL$ = SQL$ + " c.call_date, '" + TodayDate.Text + "') = 0"
    '*
    '* Execute the query and load the results into the Calls Made list
    If Exec_Query(SQL$) Then stmt% = Load_List(CallsMade)
    '*
    '* Select the first name to call, or the first name called if none
    If ToCall.ListCount > 0 Then
        '* Trigger the ToCall_Click subroutine
        ToCall.ListIndex = 0
    ElseIf CallsMade.ListCount > 0 Then
        '* Trigger the CallsMade_Click subroutine
        CallsMade.ListIndex = 0
    End If
End Sub

Sub ToCall_Click ()
    '*
    '* Retrieve data on prospect to call, and initialize contact data
    '*
    ProspectName.Text = ToCall.Text
    stmt% = Display_Profile((ProspectName.Text))
    Subject.Text = ""
    NextCallDate.Text = Format$(DateSerial(Year(Now), Month(Now), Day(Now) + 7),
"mm/dd/yy") 
End Sub

Sub CallsMade_Click ()
    '*
    '* Retrieve data on prospects called, and contact data
    '*
    ProspectName.Text = CallsMade.Text
    stmt% = Display_Profile((ProspectName.Text))
    stmt% = Contact_ByDate((ProspectName.Text), (ContactDate.Text))
End Sub

Function Display_Profile% (PName$)
    '*
    '* Get prospect data by name and display on form
    '*
    '* Query: select name of prospect.  Re-selecting the name
    '* allows the use of wildcards for search operations.
    If Exec_Query("SELECT name FROM Profile WHERE name LIKE '" + PName$ + "'") 
Then
        '* Display the name in the name field
        ProspectName.Text = Build_String()
    End If
    '*
    '* Query: select street address of prospect
    If Exec_Query("SELECT address FROM Profile WHERE name LIKE '" + PName$ + 
"'") Then
        Address.Text = Build_String()
    End If
    '*
    '* Query: select city of prospect
    If Exec_Query("SELECT city FROM Profile WHERE name LIKE '" + PName$ + "'") 
Then
        City.Text = Build_String()
    End If
    '*
    '* Query: select state of prospect
    If Exec_Query("SELECT state FROM Profile WHERE name LIKE '" + PName$ + "'") 
Then
        State.Text = Build_String()
    End If
    '*
    '* Query: select zipcode of prospect
    If Exec_Query("SELECT zipcode FROM Profile WHERE name LIKE '" + PName$ + 
"'") Then
        ZipCode.Text = Build_String()
    End If
    '*
    '* Query: select phone number of prospect
    If Exec_Query("SELECT phone FROM Profile WHERE name LIKE '" + PName$ + "'") 
Then
        phone$ = Build_String()
        '* Display the formatted phone number in the phone number field
        PhoneNumber.Text = "(" + Left$(phone$, 3) + ") " + Mid$(phone$, 4, 3) + 
"-" + Right$(phone$, 4)
    End If
    '*
    '* Query: select contact dates for prospect
    SQL$ = "SELECT convert(char(8), c.call_date, 1) FROM Profile p, contact c"
    SQL$ = SQL$ + " WHERE p.prospect_id = c.prospect_id"
    SQL$ = SQL$ + " AND p.name LIKE '" + PName$ + "'"
    If Exec_Query(SQL$) Then
        '* Load dates into the Contact Date combo
        stmt% = Load_List(ContactDate)
    End If
    '* Default Contact date to today
    ContactDate.Text = TodayDate.Text
    '*
    '* Query: select contact subjects for prospect
    SQL$ = "SELECT c.subject FROM Profile p, contact c"
    SQL$ = SQL$ + " WHERE p.prospect_id = c.prospect_id"
    SQL$ = SQL$ + " AND p.name LIKE '" + PName$ + "'"
    If Exec_Query(SQL$) Then
        '* Load subjects into the Subject combo
        stmt% = Load_List(Subject)
    End If
    '* Clear comments field
    ContactText.Text = ""
    '*
    '* Query: select next call date for prospect
    If Exec_Query("SELECT convert(char(8), next_call, 1) FROM Profile WHERE name
LIKE '" + PName$ + "'") Then
        '* Display next call date in the Next Call Date field
        NextCallDate.Text = Build_String()
    End If
End Function

Sub ContactDate_Click ()
    '* Retrieve contact information on selected date
    stmt% = Contact_ByDate((ProspectName.Text), (ContactDate.Text))
End Sub

Function Contact_ByDate% (PName$, CDate$)
    '*
    '* Get contact data by prospect name and contact date
    '* and display on form
    '*
    '* Query:  select prospect id (artificial key) by name
    If Exec_Query("SELECT prospect_id FROM Profile WHERE name LIKE '" + PName$ +
"'") Then
        '* set function variable to prospect id
        PID$ = Build_String()
    End If
    '*
    '* Query:  select subject by prospect id and date
    SQL$ = "SELECT subject FROM contact WHERE prospect_id = " + PID$
    SQL$ = SQL$ + " AND convert(char(8), call_date, 1) LIKE '" + CDate$ + "'"
    If Exec_Query(SQL$) Then
        Subject.Text = Build_String()
    End If
    '*
    '* Query:  select comments by prospect id and date
    SQL$ = "SELECT comments FROM contact WHERE prospect_id = " + PID$
    SQL$ = SQL$ + " AND convert(char(8), call_date, 1) LIKE '" + CDate$ + "'"
    If Exec_Query(SQL$) Then
        ContactText.Text = Build_String()
    End If
End Function

Sub Subject_Click ()
    '* Retrieve contact information on selected subject
    stmt% = Contact_BySubject((ProspectName.Text), (Subject.Text))
End Sub

Function Contact_BySubject% (PName$, CSubject$)
    '*
    '* Get contact data by prospect name and contact subject
    '* and display on form
    '*
    '* Query:  select prospect id (artificial key) by name
    If Exec_Query("SELECT prospect_id FROM Profile WHERE name LIKE '" + PName$ +
"'") Then
        '* set function variable to prospect id
        PID$ = Build_String()
    End If
    '*
    '* Query:  select contact date by prospect id and subject
    SQL$ = "SELECT convert(char(8), call_date, 1) FROM contact WHERE prospect_id
= " + PID$
    SQL$ = SQL$ + " AND subject LIKE '" + CSubject$ + "'"
    If Exec_Query(SQL$) Then
        ContactDate.Text = Build_String()
    End If
    '*
    '* Query:  select comments by prospect id and subject
    SQL$ = "SELECT comments FROM contact WHERE prospect_id = " + PID$
    SQL$ = SQL$ + " AND subject LIKE '" + CSubject$ + "'"
    If Exec_Query(SQL$) Then
        ContactText.Text = Build_String()
    End If
End Function

Sub Enter_Call_Click ()
    '*
    '* Application Log Contact command
    '*
    '* Query:  select prospect id (artificial key) by current name
    If Exec_Query("SELECT prospect_id FROM Profile WHERE name LIKE '" + 
ProspectName.Text + "'") Then
        '* set function variable to prospect id
        PID$ = Build_String()
    End If
    '*
    '* Query:  find the next contact number (artificial key)
    If Exec_Query("SELECT count(*) FROM contact WHERE prospect_id  = " + PID$) 
Then
        CNO$ = Str$(Val(Build_String()) + 1)
    End If
    If RTrim$((Subject.Text)) <> "" Then
        '* Query:  Add a contact record
        SQL$ = "INSERT contact SELECT " + PID$ + ", " + CNO$ + ","
        SQL$ = SQL$ + " '" + Format$(Now, "mm/dd/yy") + "',"
        SQL$ = SQL$ + " '" + Subject.Text + "', '" + ContactText.Text + "'"
        If Exec_Query(SQL$) Then
            '* Clear data buffers
            stmt% = Get_NoData()
        End If
        '* Query:  Update prospect record next call date
        SQL$ = "UPDATE Profile SET next_call = '" + NextCallDate.Text + "'"
        SQL$ = SQL$ + " WHERE prospect_id  = " + PID$
        If Exec_Query(SQL$) Then
            '* Clear data buffers
            stmt% = Get_NoData()
            RetrieveButton.Value = -1
        End If
    End If
End Sub

Sub Find_Prospect_Click ()
    '*
    '* Application Find Prospect menu command
    '*
    '* Use Input Box to prompt for name
    PName$ = InputBox$("Enter Name", "Find Prospect")
    If PName$ <> "" Then
        '* Retrieve prospect data by name
        ProspectName.Text = PName$
        stmt% = Display_Profile(PName$)
    End If
End Sub

Sub Exit_Application_Click ()
    '*
    '* Application Exit menu command
    '*
    Unload Prospect
End Sub

Sub Form_Unload (Cancel As Integer)
    '* Shutdown server connection
    stmt% = Logoff_Server()
    End
End Sub
[End of PROSPECT.TXT]
#<end ascii>


