Listing 5 -- The code we used to copy required files onto a runtime disk

;------------------------------------------------------------------------
; vendcreate() copys files over to floppy for a vendor diskette
;------------------------------------------------------------------------
Proc vendcreate()
    Private drive,odir,procname
    procname = "vendcreate"

    Clear
    ClearAll

    Lock "link"fl
    If (RetVal=False) Then
        dispmess(ErrorMessage(),"",True)
        Return
    EndIf

    ShowMenu
        "Yes" : "Continue",
        "No"  : "Return to previous menu"
    To choice

    If (choice<>"Yes") Then
        UnLock All
        Clear
        Return
    EndIf

    drive="c"
    @ 0,0 ?? "Enter drive to copy files to: "
    Accept "A1" Min "a" Max "c"
    Required
    Default "a"
    To drive

    If (DriveStatus(drive)=False) Then
        dispmess("Drive not ready.","Drive "+drive,True)
        ClearAll Clear UnLock All
        Return
    EndIf

    If (DriveSpace(drive)<1350000) Then
        dispmess("Not enough disk space.","Drive "+drive,True)
        ClearAll Clear UnLock All
        Return
    EndIf

    @ 0,0 Clear Eol
    drive=drive+":"
    Empty "link"
    Edit "link"
    PickForm "6"
    Wait Record
        Prompt "Enter vendor number to select",
        "F1 lookup, Esc cancel, F2 continue"
    Until "Esc","F2"

    If RetVal="Esc" Then
        CancelEdit
        ClearAll
        UnLock All
        Return
    EndIf

    Do_it!
    dispmess("Copying vendor master file..","Please wait.",False)
    venda1()
    Copy "vendmst" "temp1"
    Empty "temp1"
    CopyForm "temp1" "4" "temp1" "1"
    Copy "temp1" drive+"vendmst"
    Add "answer" drive+"vendmst"
    Delete "temp1"
    dispmess("Copying vendor item file...","Please wait.",False)
    venda2()

    Copy "vendcost" "temp2"
    Empty "temp2"
    Copy "temp2" drive+"vendcost"
    Add "answer" drive+"vendcost"
    Delete "temp2"
    Copy "link" drive+"link"
    dispmess("Setting up cost files...","Please wait.",False)
    Copy "cost" drive+"cost"
    Copy "costcurr" drive+"costcurr"
    Copy "costcnfg" drive+"costcnfg"
    Copy "cnfgdesc" drive+"cnfgdesc"
    Copy "vendcfte" drive+"vendcfte"
    dispmess("Copying runtime files...","Please wait.",False)
    Run Big NoRefresh "copy f:\\work\\user\\dbdata\\vendrun3\\*.* "+drive+" >
NUL"
    ClearAll
    Clear
    UnLock All

EndProc

;------------------------------------------------------------------------
; vendcpyfil() copies files from diskette to the private directory
;------------------------------------------------------------------------
Proc vendcpyfil()
    Private choice,drive,pd,procname
    procname = "vendcpyfil"
    Clear
    ClearAll
    ShowMenu
        "Yes" : "Continue",
        "No"  : "Return to previous menu"
    To choice
    If (choice<>"Yes") Then
        Clear ClearAll
        Return
    EndIf

    drive="c"
    @ 0,0 ?? "Enter drive to copy files from: "
    Accept "A1" Min "a" Max "c"
    Required
    Default "a"
    To drive

    If (DriveStatus(drive)=False) Then
        dispmess("Drive not ready.","Drive "+drive,True)
        ClearAll Clear UnLock All
        Return
    EndIf

    drive=drive+":"
    pd=PrivDir()
    If (IsTable(drive+"vendcost")=False) Then
        dispmess("Files not found on drive "+drive,"",True)
        Clear ClearAll
        Return
    EndIf

    If (IsTable(pd+"vendmsx")=True Or IsTable(pd+"vendcosx")=True) Then
        ShowMenu
            "Yes" : "Overwrite existing files",
            "No"  : "Don't overwrite existing files"
            Default "No"
        To choice
        If (choice<>"Yes") Then
            Clear ClearAll
            Return
        EndIf
    EndIf
    If (IsTable("vendmsx")=False Or IsTable("vendcosx")=False) Then
        PrivTables pd+"vendmsx",pd+"vendcosx"
    EndIf
    dispmess("Copying files to your private directory","Please wait.",False)
    Copy drive+"vendcost" pd+"vendcosx"
    Copy drive+"vendmst"  pd+"vendmsx"
    Clear ClearAll

EndProc

